/*	
 *	clipnet.h
 *
 *	lbg[N֘ÃT|[g[`
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2005 Naoyuki Sawa
 *
 *	* Sun Jul 24 04:08:00 JST 2005 Naoyuki Sawa
 *	- 쐬JnB
 *	* Tue Aug 02 06:25:00 JST 2005 Naoyuki Sawa
 *	- update_internet_checksum()Aunpack_ip_header()Apack_ip_header()ǉ܂B
 *	* Sun Aug 07 04:10:00 JST 2005 Naoyuki Sawa
 *	- ip_pack_header()Aip_unpack_header()pack_ip_header()Aunpack_ip_header()ɉ܂B
 */
#ifndef __CLIP_NET_H__
#define __CLIP_NET_H__

/****************************************************************************
 *	
 ****************************************************************************/

/* IPf[^OEwb_ (Kvȕ) */
typedef struct _IPHEADER {
	int identification;		/*  */
	int flags;			/* tO */
	int fragment_offset;		/* tOgItZbg */
	int protocol;			/* vgR */
	int source_ip_address;		/* MIPAhX */
	int destination_ip_address;	/* IPAhX */
	//
	unsigned char* data;		/* f[^ */
	int data_length;		/* f[^ */
} IPHEADER;

/****************************************************************************
 *	
 ****************************************************************************/

/* C^[lbg`FbNTvZ܂B
 * [in]
 *	data		`FbNTvZf[^̐擪AhXB
 *	size		f[^̃oCgB(TCYł\܂)
 * [out]
 *	߂l		`FbNTB($0000`$FFFF)
 * [note]
 *	* f[^̒Ƀ`FbNTtB[hꍇ́A0ݒ肵ĂĂB
 *	* UDPVMTPȂǂł́AŏIIȃ`FbNT̒ľvZʂu0000vɂȂꍇɂ
 *	  uFFFFvZbgAu0000v͓ʂȈӖ(`FbNTȂ)ƂĂ܂B
 *	  ̊֐ɂ́Au0000vuFFFFvɒu鏈͊܂߂Ă܂B
 *	  KvɉāAĂяoŁu0000vuFFFFvɒuĂB
 *	* C^[lbg`FbNT̎dĺAȉ̎QƂĂB
 *		dq: RFC 1071 (Computing the Internet Checksum)
 *		:    wC^[lbgRFCTx AXL[oŋ ( p.611`)
 */
int internet_checksum(const void* data, int size);

/* f[^̒́AC^[lbg`FbNTtB[hXV܂B
 * [in]
 *	data		`FbNTvZf[^̐擪AhXB
 *	size		f[^̃oCgB(TCYł\܂)
 *	sum_ofs		`FbNTtB[hdata΃ItZbgB
 * [note]
 *	* `FbNTtB[h́Af[^ɖ΂܂B
 *	  Ȃ킿A(size <= sum_ofs <= size-2) łKv܂B
 *	  ͈̔͂𒴂lw肳ꂽꍇAG[\Ē~܂B
 *	* ̊֐́A`FbNTtB[h0i[ă`FbNTvZA
 *	  ̌A`FbNTtB[hɖ{̃`FbNTi[܂B
 *	  ĂяoɂāA`FbNTtB[h0ɂĂKv͂܂B
 */
void update_internet_checksum(void* data, int size, int sum_ofs);

/* IPf[^O͂Awb_擾܂B
 * [in]
 *	header		wb_i[IPHEADER\́B
 *	buffer		IPf[^Oi[Ăobt@B
 *	buffer_length	obt@BۂIPf[^O傫Ă\܂B
 * [out]
 *	߂l		Ȃ΁AIPf[^ÕoCgԂ܂B
 *			̒l͓ɈӖ̂ŁAȂΐƍlĂB
 *			sȂ΁AlԂ܂B
 */
int unpack_ip_header(IPHEADER* header, const void* buffer, int buffer_length);

/* IPwb_񂩂AIPf[^OgݗĂ܂B
 * [in]
 *	header		wb_񂪊i[ĂIPHEADER\́B
 *	buffer		IPf[^Oi[obt@B
 *	buffer_length	obt@BIPf[^Oi[[ȑ傫KvłB
 * [out]
 *	߂l		Ȃ΁AIPf[^ÕoCgԂ܂B
 *			̃oCgpāAIPf[^ȎMsĂB
 *			sȂ΁AlԂ܂B
 */
int pack_ip_header(const IPHEADER* header, void* buffer, int buffer_length);

#endif /*__CLIP_NET_H__*/
